function love.load()

--Images--

update = love.graphics.newImage("img/update.png")
ship = love.graphics.newImage("img/ship.png")
gui = love.graphics.newImage("img/GUI.png")
mouse = love.graphics.newImage("img/mouse.png")

--Fonts--

TF = love.graphics.newFont( "Anonymous.ttf", 15 )
TFS = love.graphics.newFont( "Anonymous.ttf", 11 )

--Setup source code--

code = {}

for line in love.filesystem.lines("main.lua") do
  table.insert(code, line)
end

--Variables--
CX = 0
CY = 0
CXV = 0
CYV = 0
output = ""
currentl = " "
select = false
replace = false
fileout = ""
FPS = 0

--Mouse setup--
love.graphics.setMode( 800, 600, false, false, 0 )
love.mouse.setVisible(false)

--Sound setup--
bgm = love.audio.newSource("sounds/RAK.ogg", "stream")

shoot = love.audio.newSource("sounds/SFX/shoot.ogg", "static")

end

function love.update(dt)

FPS = love.timer.getFPS( )

if love.audio.getNumSources( ) == 0 then
love.audio.play(bgm)
end

if love.keyboard.isDown("a") then CXV = CXV + dt * 15 end
if love.keyboard.isDown("d") then CXV = CXV - dt * 15 end
if love.keyboard.isDown("w") then CYV = CYV + dt * 15 end
if love.keyboard.isDown("s") then CYV = CYV - dt * 15 end

if love.keyboard.isDown("q") then
CYV = CYV/1.05
CXV = CXV/1.05
end

if CXV > 0 then
CXV = CXV - dt * 1
elseif CXV < 0 then
CXV = CXV + dt * 1
end

if CYV > 0 then
CYV = CYV - dt * 1
elseif CYV < 0 then
CYV = CYV + dt * 1
end

CX = CX + CXV
CY = CY + CYV

if love.mouse.isDown("l") and love.mouse.getX( ) > 700 and love.mouse.getY( ) > 550 then 
for i=1, table.getn(code), 1 do
fileout = fileout.."\r\n"..code[i]
end
love.filesystem.write( "main.lua", fileout, all )
output = refresh()
elseif love.mouse.isDown("l") then
code = repchar(love.mouse.getX( ), love.mouse.getY( ), code, CX, CY, currentl)
replace = true
love.audio.play(shoot)
else
replace = false
end

if love.mouse.isDown("r") then
currentl = charpos(love.mouse.getX( ), love.mouse.getY( ), code, CX, CY)
select = true
love.audio.play(shoot)
else
select = false
end

end

function love.draw()

love.graphics.setFont(TF)
love.graphics.setColor( 100, 222, 64, 255 )

for x=1, table.getn(code), 1 do
love.graphics.print(code[x], CX, CY + x*13, 0, 1, 1, 0, 0, 0, 0 )
end

love.graphics.setColor( 255, 255, 255, 255 )

love.graphics.draw( gui, 0, 600-150, 0, 1, 1, 0, 0, 0, 0 )
love.graphics.draw( update, 800-100, 600-50, 0, 1, 1, 0, 0, 0, 0 )

love.graphics.setFont(TFS)
love.graphics.setColor( 100, 222, 64, 255 )
love.graphics.print(output, 300, 550, 0, 1, 1, 0, 0, 0, 0 )

love.graphics.setFont(TF)
love.graphics.print("Current letter: "..currentl, 50, 550, 0, 1, 1, 0, 0, 0, 0 )
love.graphics.print("FPS: "..FPS, 50, 575, 0, 1, 1, 0, 0, 0, 0 )

love.graphics.setColor( 255, 255, 255, 255 )
love.graphics.draw( mouse, love.mouse.getX( ), love.mouse.getY( ), 0, 1, 1, 0, 0, 0, 0 )

if select == true then
love.graphics.setColor( 230, 0, 0, 100 )
love.graphics.line( 800/2, 600/2, love.mouse.getX( ) + 15 / 2, love.mouse.getY( ) + 15 / 2 )
end

if replace == true then
love.graphics.setColor( 0, 230, 0, 100 )
love.graphics.line( 800/2, 600/2, love.mouse.getX( ) + 15 / 2, love.mouse.getY( ) + 15 / 2 )
end

love.graphics.setColor( 255, 255, 255, 255 )
love.graphics.draw( ship, 800/2, 600/2, 0, 1, 1, 11/2, 15/2, 0, 0 )

end

local function load(filename)
   local ok, chunk, result
   ok, chunk = pcall( love.filesystem.load, filename ) -- load the chunk safely
   if not ok then
     return 'The chunk was not loaded correctly'
   else
     ok, result = pcall(chunk) -- execute the chunk safely

     if not ok then -- will be false if there is an error
      return 'Syntax Error'
     else
	  return 'Loading Successful'
     end
   end
end

function refresh()
   return load("main.lua")
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function charpos(x, y, arr, OX, OY)
if round(y/13-OY/13) > 0 and round(y/13-OY/13) < table.getn(code) + 1 then
rtrn = arr[round(y/13-OY/13)]
return string.sub(rtrn, round(x/10)-round(OX/10)+1, round(x/10)-round(OX/10)+1)
else
return " "
end
end

function repchar(x, y, arr, OX, OY, char)
if round(y/13-OY/13) > 0 and round(y/13-OY/13) < table.getn(code) + 1 then
rtrn = arr[round(y/13-OY/13)]
rtrn = rep(x/10+2-OX/10, rtrn, char)
arr[round(y/13-OY/13)] = rtrn

return arr
end
end

function rep(pos, str, r)
    return table.concat{str:sub(1,pos-1), r, str:sub(pos+1)}
end
